
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>了解JavaScript函数式编程（二） / iVAN</title>

    <meta name="description" content="了解JavaScript函数式编程（二） 上一篇文章里我们提到了纯函数的概念,所谓的纯函数就是,对于相同的输入,永远会得到相同的输出,而且没有任何可观察的副作用,也不依赖外部环境的状态(我偷懒复制过来的). 但是实际的编程中,特别是前端的编程范畴里,&quot;不依赖外部环境&quot;这个条件是根本不可能的,我们总是不可避免地接触到 DOM.AJAX 这些状态随时都在变化的东西.所以我们需要用更强大的技术来干这些脏活. 一.容器.Functor 如果你熟悉 jQuery 的话,应该还记得,$(...) 返回的对象并不是一个原生的 DO ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">了解JavaScript函数式编程（二）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDEvODUvQUIvd0tpb20xZXI1MEtnZ1c4cUFBT0JJR2pMYlBBMTA2LnBuZy13aF82NTF4LXNfODE2MzMyMDYxLnBuZw==.jpg"></p>
<p>上一篇文章里我们提到了纯函数的概念，所谓的纯函数就是，对于相同的输入，永远会得到相同的输出，而且没有任何可观察的副作用，也不依赖外部环境的状态(我偷懒复制过来的)。</p>
<p>但是实际的编程中，特别是前端的编程范畴里，“不依赖外部环境”这个条件是根本不可能的，我们总是不可避免地接触到 DOM、AJAX  这些状态随时都在变化的东西。所以我们需要用更强大的技术来干这些脏活。</p>
<p><strong>一、容器、Functor</strong></p>
<p>如果你熟悉 jQuery 的话，应该还记得，$(...) 返回的对象并不是一个原生的 DOM 对象，而是对于原生对象的一种封装：</p>
<pre>
</pre>
<ol>
<li>var foo = $('#foo'); </li>
<li> </li>
<li>foo == document.getElementById('foo'); </li>
<li> </li>
<li>//=&gt; false </li>
<li> </li>
<li>foo[0] == document.getElementById('foo'); </li>
<li> </li>
<li>//=&gt; true </li>
</ol>
<p>这在某种意义上就是一个“容器”(但它并不函数式)。</p>
<p>接下类我们会看到，容器为函数式编程里普通的变量、对象、函数提供了一层极其强大的外衣，赋予了它们一些很惊艳的特性，就好像 Tony Stark  的钢铁外衣，Dva 的机甲，明日香的2号机一样。</p>
<p>下面我们就来写一个最简单的容器吧：</p>
<pre>
</pre>
<ol>
<li>var Container = function(x) { </li>
<li> </li>
<li>this.__value = x; </li>
<li> </li>
<li>} </li>
<li> </li>
<li>Container.of = x =&gt; new Container(x); </li>
<li> </li>
<li>//试试看 </li>
<li> </li>
<li>Container.of(1); </li>
<li> </li>
<li>//=&gt; Container(1) </li>
<li> </li>
<li>Container.of('abcd'); </li>
<li> </li>
<li>//=&gt; Container('abcd') </li>
</ol>
<p>我们调用 Container.of  把东西装进容器里之后，由于这一层外壳的阻挡，普通的函数就对他们不再起作用了，所以我们需要加一个接口来让外部的函数也能作用到容器里面的值：</p>
<pre>
</pre>
<ol>
<li>Container.prototype.map = function(f){ </li>
<li> </li>
<li>return Container.of(f(this.__value)) </li>
<li> </li>
<li>} </li>
</ol>
<p>我们可以这样使用它：</p>
<pre>
</pre>
<ol>
<li>Container.of(3) </li>
<li> </li>
<li>.map(x =&gt; x + 1) //=&gt; Container(4) </li>
<li> </li>
<li>.map(x =&gt; 'Result is ' + x); //=&gt; Container('Result is 4') </li>
</ol>
<p>没错!我们仅花了 7 行代码就实现了很炫的链式调用，这也是我们的第一个 Functor。</p>
<p>Functor(函子)是实现了 map 并遵守一些特定规则的容器类型。</p>
<p>也就是说，如果我们要将普通函数应用到一个被容器包裹的值，那么我们首先需要定义一个叫 Functor 的数据类型，在这个数据类型中需要定义如何使用 map  来应用这个普通函数。</p>
<p>把东西装进一个容器，只留出一个接口 map 给容器外的函数，这么做有什么好处呢?</p>
<p>本质上，Functor 是一个对于函数调用的抽象，我们赋予容器自己去调用函数的能力。当 map  一个函数时，我们让容器自己来运行这个函数，这样容器就可以自由地选择何时何地如何操作这个函数，以致于拥有惰性求值、错误处理、异步调用等等非常牛掰的特性。</p>
<p>举个例子，我们现在为 map 函数添加一个检查空值的特性，这个新的容器我们称之为 Maybe(原型来自于Haskell)：</p>
<pre>
</pre>
<ol>
<li>var Maybe = function(x) { </li>
<li> </li>
<li>this.__value = x; </li>
<li> </li>
<li>} </li>
<li> </li>
<li>Maybe.of = function(x) { </li>
<li> </li>
<li>return new Maybe(x); </li>
<li> </li>
<li>} </li>
<li> </li>
<li>Maybe.prototype.map = function(f) { </li>
<li> </li>
<li>return this.isNothing() ? Maybe.of(null) : Maybe.of(f(this.__value)); </li>
<li> </li>
<li>} </li>
<li> </li>
<li>Maybe.prototype.isNothing = function() { </li>
<li> </li>
<li>return (this.__value === null || this.__value === undefined); </li>
<li> </li>
<li>} </li>
<li> </li>
<li>//试试看 </li>
<li> </li>
<li>import _ from 'lodash'; </li>
<li> </li>
<li>var add = _.curry(_.add); </li>
<li> </li>
<li>Maybe.of({name: "Stark"}) </li>
<li> </li>
<li>.map(_.prop("age")) </li>
<li> </li>
<li>.map(add(10)); </li>
<li> </li>
<li>//=&gt; Maybe(null) </li>
<li> </li>
<li>Maybe.of({name: "Stark", age: 21}) </li>
<li> </li>
<li>.map(_.prop("age")) </li>
<li> </li>
<li>.map(add(10)); </li>
<li> </li>
<li>//=&gt; Maybe(31) </li>
</ol>
<p>看了这些代码，觉得链式调用总是要输入一堆 .map(...) 很烦对吧?这个问题很好解决，还记得我们上一篇文章里介绍的柯里化吗?</p>
<p>有了柯里化这个强大的工具，我们可以这样写：</p>
<pre>
</pre>
<ol>
<li>import _ from 'lodash'; </li>
<li> </li>
<li>var compose = _.flowRight; </li>
<li> </li>
<li>var add = _.curry(_.add); </li>
<li> </li>
<li>// 创造一个柯里化的 map </li>
<li> </li>
<li>var map = _.curry((f, functor) =&gt; functor.map(f)); </li>
<li> </li>
<li>var doEverything = map(compose(add(10), _.property("age"))); </li>
<li> </li>
<li>var functor = Maybe.of({name: "Stark", age: 21}); </li>
<li> </li>
<li>doEverything(functor); </li>
<li> </li>
<li>//=&gt; Maybe(31) </li>
</ol>
<p><strong>二、错误处理、Either</strong></p>
<p>现在我们的容器能做的事情太少了，它甚至连做简单的错误处理都做不到，现在我们只能类似这样处理错误：</p>
<pre>
</pre>
<ol>
<li>try{ </li>
<li> </li>
<li>doSomething(); </li>
<li> </li>
<li>}catch(e){ </li>
<li> </li>
<li>// 错误处理 </li>
<li> </li>
<li>} </li>
</ol>
<p>try/catch/throw 并不是“纯”的，因为它从外部接管了我们的函数，并且在这个函数出错时抛弃了它的返回值。这不是我们期望的函数式的行为。</p>
<p>如果你对 Promise 熟悉的话应该还记得，Promise 是可以调用 catch 来集中处理错误的：</p>
<pre>
</pre>
<ol>
<li>doSomething() </li>
<li> </li>
<li>.then(async1) </li>
<li> </li>
<li>.then(async2) </li>
<li> </li>
<li>.catch(e =&gt; console.log(e)); </li>
</ol>
<p>对于函数式编程我们也可以做同样的操作，如果运行正确，那么就返回正确的结果;如果错误，就返回一个用于描述错误的结果。这个概念在 Haskell 中称之为  Either 类，Left 和 Right 是它的两个子类。我们用 JS 来实现一下：</p>
<pre>
</pre>
<ol>
<li>// 这里是一样的=。= </li>
<li> </li>
<li>var Left = function(x) { </li>
<li> </li>
<li>this.__value = x; </li>
<li> </li>
<li>} </li>
<li> </li>
<li>var Right = function(x) { </li>
<li> </li>
<li>this.__value = x; </li>
<li> </li>
<li>} </li>
<li> </li>
<li>// 这里也是一样的=。= </li>
<li> </li>
<li>Left.of = function(x) { </li>
<li> </li>
<li>return new Left(x); </li>
<li> </li>
<li>} </li>
<li> </li>
<li>Right.of = function(x) { </li>
<li> </li>
<li>return new Right(x); </li>
<li> </li>
<li>} </li>
<li> </li>
<li>// 这里不同!!! </li>
<li> </li>
<li>Left.prototype.map = function(f) { </li>
<li> </li>
<li>return this; </li>
<li> </li>
<li>} </li>
<li> </li>
<li>Right.prototype.map = function(f) { </li>
<li> </li>
<li>return Right.of(f(this.__value)); </li>
<li> </li>
<li>} </li>
</ol>
<p>下面来看看 Left 和 Right 的区别吧：</p>
<pre>
</pre>
<ol>
<li>Right.of("Hello").map(str =&gt; str + " World!"); </li>
<li> </li>
<li>// Right("Hello World!") </li>
<li> </li>
<li>Left.of("Hello").map(str =&gt; str + " World!"); </li>
<li> </li>
<li>// Left("Hello") </li>
</ol>
<p>Left 和 Right 唯一的区别就在于 map 方法的实现，Right.map 的行为和我们之前提到的 map 函数一样。但是<br />
Left.map  就很不同了：它不会对容器做任何事情，只是很简单地把这个容器拿进来又扔出去。这个特性意味着，Left<br />
可以用来传递一个错误消息。</p>
<pre>
</pre>
<ol>
<li>var getAge = user =&gt; user.age ? Right.of(user.age) : Left.of("ERROR!"); </li>
<li> </li>
<li>//试试 </li>
<li> </li>
<li>getAge({name: 'stark', age: '21'}).map(age =&gt; 'Age is ' + age); </li>
<li> </li>
<li>//=&gt; Right('Age is 21') </li>
<li> </li>
<li>getAge({name: 'stark'}).map(age =&gt; 'Age is ' + age); </li>
<li> </li>
<li>//=&gt; Left('ERROR!') </li>
</ol>
<p>是的，Left 可以让调用链中任意一环的错误立刻返回到调用链的尾部，这给我们错误处理带来了很大的方便，再也不用一层又一层的try/catch。</p>
<p>Left 和 Right 是 Either 类的两个子类，事实上 Either  并不只是用来做错误处理的，它表示了逻辑或，范畴学里的coproduct。但这些超出了我们的讨论范围。</p>
<p><strong>三、IO</strong></p>
<p>下面我们的程序要走出象牙塔，去接触外面“肮脏”的世界了，在这个世界里，很多事情都是有副作用的或者依赖于外部环境的，比如下面这样：</p>
<pre>
</pre>
<ol>
<li>function readLocalStorage(){ </li>
<li> </li>
<li>  return window.localStorage; </li>
<li> </li>
<li>} </li>
</ol>
<p>这个函数显然不是纯函数，因为它强依赖外部的 window.localStorage  这个对象，它的返回值会随着环境的变化而变化。为了让它“纯”起来，我们可以把它包裹在一个函数内部，延迟执行它：</p>
<pre>
</pre>
<ol>
<li>function readLocalStorage(){ </li>
<li> </li>
<li>  return function(){ </li>
<li> </li>
<li>    return window.localStorage; </li>
<li> </li>
<li>  } </li>
<li>} </li>
</ol>
<p>这样 readLocalStorage 就变成了一个真正的纯函数! OvO为机智的程序员鼓掌!</p>
<p>额……好吧……好像确实没什么卵用……我们只是(像大多数拖延症晚期患者那样)把讨厌做的事情暂时搁置了而已。为了能彻底解决这些讨厌的事情，我们需要一个叫 IO  的新的 Functor：</p>
<pre>
</pre>
<ol>
<li>import _ from 'lodash'; </li>
<li> </li>
<li>var compose = _.flowRight; </li>
<li> </li>
<li>var IO = function(f) { </li>
<li> </li>
<li>this.__value = f; </li>
<li> </li>
<li>} </li>
<li> </li>
<li>IO.of = x =&gt; new IO(_ =&gt; x); </li>
<li> </li>
<li>IO.prototype.map = function(f) { </li>
<li> </li>
<li>return new IO(compose(f, this.__value)) </li>
<li> </li>
<li>}; </li>
</ol>
<p>IO 跟前面那几个 functor 不同的地方在于，它的 __value 是一个函数。它把不纯的操作(比如  IO、网络请求、DOM)包裹到一个函数内，从而延迟这个操作的执行。所以我们认为，IO 包含的是被包裹的操作的返回值。</p>
<pre>
</pre>
<ol>
<li>var io_document = new IO(_ =&gt; window.document); </li>
<li> </li>
<li>io_document.map(function(doc){ return doc.title }); </li>
<li> </li>
<li>//=&gt; IO(document.title) </li>
</ol>
<p>注意我们这里虽然感觉上返回了一个实际的值 IO(document.title)，但事实上只是一个对象：{ __value:<br />
[Function]  }，它并没有执行，而是简单地把我们想要的操作存了起来，只有当我们在真的需要这个值得时候，IO<br />
才会真的开始求值，这个特性我们称之为  惰性求值。(培提尔其乌斯：“这是怠惰啊!”)</p>
<p>是的，我们依然需要某种方法让 IO 开始求值，并且把它返回给我们。它可能因为 map<br />
的调用链积累了很多很多不纯的操作，一旦开始求值，就可能会把本来很干净的程序给“弄脏”。但是去直接执行这些“脏”操作不同，我们把这些不纯的操作带来的复杂性和不可维护性推到了<br />
  IO 的调用者身上(嗯就是这么不负责任)。</p>
<p>下面我们来做稍微复杂点的事情，编写一个函数，从当前 url 中解析出对应的参数。</p>
<pre>
</pre>
<ol>
<li>import _ from 'lodash'; </li>
<li> </li>
<li>// 先来几个基础函数： </li>
<li> </li>
<li>// 字符串 </li>
<li> </li>
<li>var split = _.curry((char, str) =&gt; str.split(char)); </li>
<li> </li>
<li>// 数组 </li>
<li> </li>
<li>var first = arr =&gt; arr[0]; </li>
<li> </li>
<li>var last = arr =&gt; arr[arr.length - 1]; </li>
<li> </li>
<li>var filter = _.curry((f, arr) =&gt; arr.filter(f)); </li>
<li> </li>
<li>//注意这里的 x 既可以是数组，也可以是 functor </li>
<li> </li>
<li>var map = _.curry((f, x) =&gt; x.map(f)); </li>
<li> </li>
<li>// 判断 </li>
<li> </li>
<li>var eq = _.curry((x, y) =&gt; x == y); </li>
<li> </li>
<li>// 结合 </li>
<li> </li>
<li>var compose = _.flowRight; </li>
<li> </li>
<li>var toPairs = compose(map(split('=')), split('&amp;')); </li>
<li> </li>
<li>// toPairs('a=1&amp;b=2') </li>
<li> </li>
<li>//=&gt; [['a', '1'], ['b', '2']] </li>
<li> </li>
<li>var params = compose(toPairs, last, split('?')); </li>
<li> </li>
<li>// params('http://xxx.com?a=1&amp;b=2') </li>
<li> </li>
<li>//=&gt; [['a', '1'], ['b', '2']] </li>
<li> </li>
<li>// 这里会有些难懂=。= 慢慢看 </li>
<li> </li>
<li>// 1.首先我们先对 url 调用 params 函数，得到类似[['a', '1'], ['b', '2']] </li>
<li> </li>
<li>// 这样的数组; </li>
<li> </li>
<li>// 2.然后调用 filter(compose(eq(key), first))，这是一个过滤器，过滤的 </li>
<li> </li>
<li>// 条件是 compose(eq(key), first) 为真，它的意思就是只留下首项为 key </li>
<li> </li>
<li>// 的数组; </li>
<li> </li>
<li>// 3.最后调用 Maybe.of，把它包装起来。 </li>
<li> </li>
<li>// 4.这一系列的调用是针对 IO 的，所以我们用 map 把这些调用封装起来。 </li>
<li> </li>
<li>var getParam = key =&gt; map(compose(Maybe.of, filter(compose(eq(key), first)), params)); </li>
<li> </li>
<li>// 创建充满了洪荒之力的 IO!!! </li>
<li> </li>
<li>var url = new IO(_ =&gt; window.location.href); </li>
<li> </li>
<li>// 最终的调用函数!!! </li>
<li> </li>
<li>var findParam = getParam(url); </li>
<li> </li>
<li>// 上面的代码都是很干净的纯函数，下面我们来对它求值，求值的过程是非纯的。 </li>
<li> </li>
<li>// 假设现在的 url 是 http://xxx.com?a=1&amp;b=2 </li>
<li> </li>
<li>// 调用 __value() 来运行它! </li>
<li> </li>
<li>findParam("a").__value(); </li>
<li> </li>
<li>//=&gt; Maybe(['a', '1']) </li>
</ol>
<p><strong>四、总结</strong></p>
<p>如果你还能坚持看到这里的话，不管看没看懂，已经是勇士了。在这篇文章里，我们先后提到了 Maybe、Either、IO 这三种强大的<br />
functor，在链式调用、惰性求值、错误捕获、输入输出中都发挥着巨大的作用。事实上 functor<br />
远不止这三种，但由于篇幅的问题就不再继续介绍了(哼才不告诉你其实是因为我还没看懂其它 functor 的原理)</p>
<p>但依然有问题困扰着我们：</p>
<ol>
<li>如何处理嵌套的 functor 呢?(比如 Maybe(IO(42)))</li>
<li>如何处理一个由非纯的或者异步的操作序列呢?</li>
</ol>
<p>作者：王伟嘉</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:58:21</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%b1%bb%e5%9e%8b/" title="数据类型">数据类型</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b/" title="编程">编程</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8/" title="容器">容器</a>, <a href="https://www.iamivan.net/tag/prototype/" title="prototype">prototype</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>了解JavaScript函数式编程（二）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M91VPvM.html" rel="bookmark">javascript函数式编程实例分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了javascript函数式编程,实例分析了javascript函数式编程的相关使用技巧,非常具有实用价值,需要的朋友可以参考下 本文实例讲述了javascript函数式编程.分享给大家供大家参考.具体分析如下: js像其他动态语言一样是可以写高阶函数的,所谓高阶函数是可以操作函数的函数.因为在js中函数是一个彻彻底底的对象,属于第一类公民,这提供了函数式编程的先决条件. 下面给出一个例子代码,出自一本js教程,功能是计算数组元素的平均值和标准差,先列出非函数式编程的一种写法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL52eaz.html" rel="bookmark">javascript函数式编程实例分析&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了javascript函数式编程.分享给大家供大家参考.具体分析如下: js像其他动态语言一样是可以写高阶函数的,所谓高阶函数是可以操作函数的函数.因为在js中函数是一个彻彻底底的对象,属于第一类公民,这提供了函数式编程的先决条件. 下面给出一个例子代码,出自一本js教程,功能是计算数组元素的平均值和标准差,先列出非函数式编程的一种写法: var data = [1,1,3,5,5]; var total = 0; for(var i = 0;i &lt; data.length;i++)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8GW09M.html" rel="bookmark">我眼中的JavaScript函数式编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript 函数式编程是一个存在了很久的话题,但似乎从 2016 年开始,它变得越来越火热.这可能是因为 ES6 语法对于函数式编程更为友好,也可能是因为诸如 RxJS (ReactiveX) 等函数式框架的流行. 看过许多关于函数式编程的讲解,但是其中大部分是停留在理论层面,还有一些是仅针对 Haskell 等纯函数式编程语言的.而本文旨在聊一聊我眼中的函数式编程在 JavaScript 中的具体实践,之所以是 &quot;我眼中的&quot; 即我所说的仅代表个人观点,可能和部分 严格概念 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEYEvJb.html" rel="bookmark">Javascript函数式编程简单介绍&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				几十年来,函数式编程一直是计算机科学狂热者的至爱,由于数学的纯洁性和谜一般的本质, 它被埋藏在计算机实验室,只有数据学家和有希望获得博士学位的人士使用.但是现在,它正经历一场复兴, 这要感谢一些现代语言比如Python,Julia,Ruby,Clojure以及--但不是最后一个--Javascript. 你是说Javascript?这个WEB脚本语言?没错! Javascript已经被证明是一项长期以来都没有消失的重要的技术.这主要是由于它扩展的一些框架和库而使其具有重生的能力, 比如backb			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwKrv5z.html" rel="bookmark">浅谈javascript函数式编程&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				函数式编程,属于编程范式的一种 1 函数是第一公民,可以返回值,也可以作为其他函数的参数 //console是一个函数 function con(v){ console.log(v) } // execute 也是一个函数 function execute(fn){ fn(1) } //将con函数作为参数传进execute函数 execute(con) // 1 2 接近自然语言的写法   晓池吃完饭然后就去洗澡 可以表现为eat().bathe() // 吃饭函数 function eat(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0yZ0p.html" rel="bookmark">探究JavaScript函数式编程的乐趣&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编程范式 编程范式是一个由思考问题以及实现问题愿景的工具组成的框架.很多现代语言都是聚范式(或者说多重范式): 他们支持很多不同的编程范式,比如面向对象,元程序设计,泛函,面向过程,等等. 函数式编程范式 函数式编程就像一辆氢燃料驱动的汽车--先进的未来派,但是还没有被广泛推广.与命令式编程相反,他由一系列语句组成,这些语句用于更新执行时的全局状态.函数式编程将计算转化作表达式求值.这些表达式全由纯数学函数组成,这些数学函数都是一流的(可以被当做一般值来运用和处理),并且没有副作用. 函数式编程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvJWP8M.html" rel="bookmark">《JavaScript函数式编程》读后感&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文章记录本人在学习 函数式 中理解到的一些东西,加深记忆和并且整理记录下来,方便之后的复习. 在近期看到了&lt;JavaScript函数式编程&gt;这本书预售的时候就定了下来.主要目的是个人目前还是不理解什么是函数式编程.在自己学习的过程中一直听到身边的人说面向过程编程和面向对象编程,而函数式就非常少.为了自己不要落后于其他同学的脚步,故想以写笔记的方式去分享和记录自己阅读中所汲取的知识. js 和函数式编程 书中用了一句简单的话来回答了什么是函数式编程: 函数式编程通过使用函数来将值转换为抽象单元			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPP1vAp.html" rel="bookmark">了解JavaScript函数式编程（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.引言 说到函数式编程,大家可能第一印象都是学院派的那些晦涩难懂的代码,充满了一大堆抽象的不知所云的符号,似乎只有大学里的计算机教授才会使用这些东西.在曾经的某个时代可能确实如此,但是近年来随着技术的发展,函数式编程已经在实际生产中发挥巨大的作用了,越来越多的语言开始加入闭包,匿名函数等非常典型的函数式编程的特性,从某种程度上来讲,函数式编程正在逐步&quot;同化&quot;命令式编程. JavaScript 作为一种典型的多范式编程语言,这两年随着React的火热,函数式编程的概念也开始流行起来,R			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Yo4Bz.html" rel="bookmark">javascript函数式编程一例分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js像其他动态语言一样是可以写高阶函数的,所谓高阶函数是可以操作函数的函数.因为在js中函数是一个彻彻底底的对象,属于第一类公民,这提供了函数式编程的先决条件. 下面给出一个例子代码,出自一本js教程,功能是计算数组元素的平均值和标准差,先列出非函数式编程的一种写法: var data = [1,1,3,5,5]; var total = 0; for(var i = 0;i &lt; data.length;i++) total += data[i]; var mean = tatal/data.l			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDjxOM.html" rel="bookmark" class="title">ASP生成html静态页面</a>
					<div>
						原理:通过浏览器传送变量,如 http://127.0.0.1/shengcheng.asp?id=90 代码: if SaveFile(&quot;/new/&quot;&amp;id&amp;&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9gY3z.html" rel="bookmark" class="title">实例解析：用ASP建造自己的聊天室</a>
					<div>
						聊天|聊天室 聊天室想必你一定去过吧,但想不想建立自己的聊天室呢?其实这一点都不难,Active Server Script提供了Application对象和Session对象,Application ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE943b.html" rel="bookmark" class="title">flash经典20问答</a>
					<div>
						1.怎么才能让音乐和动画同步在声音属性里设置音乐成为数据流格式! 在输出的声音选项里选择MP3,比特率为16kbps,品质为快速. 2.尽管设置了影片大小,但播放时只要拖大窗口还是会看到原来不希望看到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq3Q2z.html" rel="bookmark" class="title">Oracle9i初始化参数中文说明5</a>
					<div>
						oracle|中文 partition_view_enabled: 说明: 如果将 PARTITION_VIEW_ENABLED 设置为 TRUE, 该优化程序将剪除 (或跳过) 分区视图中不必要的表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze46mNp.html" rel="bookmark" class="title">专家博客：永流传的石碑与易丢失的数字档案</a>
					<div>
						本文作者Henry Newman是一位行业顾问,在高性能计算服务和存储领域有着28年的从业经验. 我与拙荆曾在去年秋季在纽约中央花园看到一块有着近4000年历史的埃及方尖石碑,石碑保存得相当完好,碑文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7jg2M.html" rel="bookmark" class="title">OpenRisc入门（27） wishbone接口的vga ipcore的分析与仿真</a>
					<div>
						引言 图形,总是给人直观的感觉.想让ORPSoC能有image/video的输出,是一件很有意义的事情,而VGA就是其中一个不错的选择. 本小节就分析一下一个wishbone接口的vga模块. 1,模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPDPjM.html" rel="bookmark" class="title">C&plus;&plus;实现&period;NET风格的委托</a>
					<div>
						引言 在.NET中,委托被用来实现事件处理.它允许一个类(方法)先注册一个事件,然后当此事件被引发时此注册的方法就会被调用.在非.Net环境的C++中,这并不是一件容易的事,尤其是类的非静态成员函数, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yn3oz.html" rel="bookmark" class="title">深入浅出Java堆的管理</a>
					<div>
						引言 java的堆是一个运行时数据区,类的实例(对象)从中分配空间.java虚拟机(jvm)的堆中储存着正在运行的应用程序所建立的所有对象,这些对象通过new.newarray.anewarray和m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2y3Xkz.html" rel="bookmark" class="title">制作便携版 FireFox 火狐浏览器</a>
					<div>
						Firefox是一款可高度自定义的开源浏览器: 你可以访问 火狐DIY 定制自己的Firefox安装包, 此外,你还可以自己动手定制一款可以放在U盘随身携带的便携版Firefox火狐浏览器. 制作便携 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPo18z.html" rel="bookmark" class="title">向Fireworks文档中插入对象</a>
					<div>
						  将图像或文本拖动到 Fireworks 中 可以从支持拖动操作的任何应用程序拖动矢量对象.位图图像或文本. ❖ 将对象或文本从其它应用程序拖到 Fireworks 中. 粘贴到 Fireworks ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPEdGz.html" rel="bookmark" class="title">ubuntu系统下gedit出现中文乱码的两种解决方法</a>
					<div>
						  ubuntu gedit中文乱码看起来很烦人,本文提供两种解决途径,终端命令行途径或者图形界面操作途径,其实原理都是增加编码类型,问题显示如下图,查看文档内容,发现乱码 方法一:终端途径 1.打开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKRGoM.html" rel="bookmark" class="title">Word教程 如何快速批量删除图片</a>
					<div>
						  今天的word教程就是教大家如快速批量删除图片的,如果也想知道操作的方法,那就进来学习咯,以下是详细的操作步骤: 1.启动Word2007,打开插入有图片的文档,按下Ctrl+H键,打开查找与替换 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badDLnz.html" rel="bookmark" class="title">电脑本地连接没有了网络连接的本地连接不见的解决方法</a>
					<div>
						经常遇见许多朋友反映自己电脑本地连接没有了,但是至于所造成的原因却各不相同.有人说不见了之后,还可以继续正常上网;而有的人说,根本无法连接网络.今天,脚本之家小编就就来和大家一起去探其下本地连接没有了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3XRZM.html" rel="bookmark" class="title">如何更改文件夹图标？</a>
					<div>
						  很多网友都会好奇:电脑的文件夹图标可以修改吗?关于这个问题,小编给出的答案是:肯定可以修改,那么,如何更改文件夹图标呢?今天,我们就一起来学习一下文件夹图标修改的两个方法,他们包括系统原生修改以及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7YG2z.html" rel="bookmark" class="title">野外无线数据传输的问题&quest;</a>
					<div>
						问题描述 野外无线数据传输的问题? 荒郊野外,需要把数据传输到后台服务器,数据量不大,一天传输一次,地域范围比较广,沙漠.无人区占的比重较大.穿越几个国家,这种形式的无线传输,大家讨论一下,用什么形式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QYODp.html" rel="bookmark" class="title">windows8 分区 &plus;&plus;-Windows如何Mount分区</a>
					<div>
						问题描述 Windows如何Mount分区 windows里自带的diskpart软件可以用list partition列出所有分区,然后用assign letter='b'这样的形式mount某分区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7mZxp.html" rel="bookmark" class="title">软区域</a>
					<div>
						(以下内容转自:个人管理 - 学习的心态) 软区域 印度有一个寓言故事:一个人想步行穿过大陆,但道路布满了荆棘,这时候他有两种选择:铺一条路,征服大自然,或者,准备一双草鞋. 硬区域 要求有一个合作的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7OmKz.html" rel="bookmark" class="title">本机测试域名，局域网其他机器访问</a>
					<div>
						最近一直在搞网站方面的研究,现在遇到一个问题就是在本地随便弄一个域名,比如:muzi.lanni.com,然后想让局域网中的机器通过此域名方面自己搭建的网站. 我们大家肯定都知道在本机的hosts文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1l1g3b.html" rel="bookmark" class="title">Android ADB 怎么操作手机剪贴板，如何读取和写入剪贴板内容？</a>
					<div>
						问题描述 Android ADB 怎么操作手机剪贴板,如何读取和写入剪贴板内容? 网上搜索到这个命令:shell service call clipboard 1 但没有正确返回内容,总是提示:i A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN799Wp.html" rel="bookmark" class="title">数据库优化和SQL操作的相关题目</a>
					<div>
						SQL操作 1.有一个数据库表peope,表有字段name,age,address三个属性(注:没有主键).现在如果表中有重复的数据,请删去重复只留下其中的一条.重复的定义就是两条记录的name,ag ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxA9nb.html" rel="bookmark" class="title">新手求教，关于传递字符串数组的问题</a>
					<div>
						问题描述 新手求教,关于传递字符串数组的问题 以下是我写的c primer plus 第11章习题10的程序,问题是我输入字符串后,用1以外的方式排序,就无法恢复原序列了.也就是每次调用函数都改变了原 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjyXZp.html" rel="bookmark" class="title">PostgreSQL 事件触发器应用 - DDL审计</a>
					<div>
						标签 PostgreSQL , 事件触发器 , DDL审计 , 表结构变更 , 建表等审计 背景 DDL语句的审计是非常重要的,目前PG的DDL审计记录在日志文件中.不便于查看. 为了让DDL事件记录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEO1xz.html" rel="bookmark" class="title">华为路由器与Cisco 路由器规定的路由协议优先级比较</a>
					<div>
						本文主要讲述了 华为路由器和 思科路由器的协议优先级比较,详细 此文对于IT业内人士有很大的帮助,相关人员看后会对此有一定的了解.华为路由器规定的 路由协议优先级为: 路由协议 | 优先级 ----- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAY3ZM.html" rel="bookmark" class="title">linux-Linux系统安装开源软件的问题？</a>
					<div>
						问题描述 Linux系统安装开源软件的问题? 我想问问这是什么原因呢 ,该怎么去解决 求大神 解决方案 需要先configure一下,生成makefile 解决方案二: pkg_config_path ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAxjQM.html" rel="bookmark" class="title">web 通讯 des加密 中文乱码</a>
					<div>
						问题描述 通讯:客户端将上行通过des加密,秘钥url挂参传输.服务器接收到客户端的上行进行解密,不论中英文都是正常的.然后,服务器将下行des加密,响应到客户端,客户端解密之后就出现中文乱码.(不存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7VvZz.html" rel="bookmark" class="title">变革！大数据时代的商业智能</a>
					<div>
						在社交网络.移动应用等日趋火热的同时,我们可以看到网络信息的数据量在日益增多,与此同时,网络负载也随之加大,这给予网络运营商及企业信息发展带来一定数据压力.据IDC最新报告预测,到2015年大数据技术 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAE3PeM.html" rel="bookmark" class="title">gor-求大神赐予一个Gor的安装包</a>
					<div>
						问题描述 求大神赐予一个Gor的安装包 官网的安装包解压后是一个文件,但是文件不能运行,不知道怎么解决,请求哪位大神指点一下或者给一个直接运行的安装包,非常感谢 解决方案 我也没有- - 啊实打实打算					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKK1LM.html" rel="bookmark" class="title">javascript中负数算术右移、逻辑右移的奥秘探索&lowbar;javascript技巧</a>
					<div>
						javascript中负数的算术右移和逻辑右移都十分的让人迷惑,特别是逻辑右移&gt;&gt;&gt;,你会发现即使一个很小的负数,右移之后,也会得到一个无比巨大的数,这是为什么呢? 原来在逻辑右移中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVLg7z.html" rel="bookmark" class="title">JavaScript File API实现文件上传预览&lowbar;javascript技巧</a>
					<div>
						一.概述以往对于基于浏览器的应用而言,访问本地文件都是一件头疼的事情.虽然伴随着 Web 2.0 应用技术的不断发展,JavaScript 正在扮演越来越重要的角色,但是出于安全性的考虑,JavaSc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9j9WKp.html" rel="bookmark" class="title">js 剪切板应用clipboardData详细解析&lowbar;javascript技巧</a>
					<div>
						注意:ie7,与ie8 对网页有个复制的权限,需在&quot;安全&quot;中的&quot;自定义级别&quot;的脚本中设置 clipboardData 对象 提供了对剪贴板的访问. 三个方法 1 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
